/*
	header file for PROforma
	definition of a Gstate object

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 10 July 1993

	19.03.1993 adjusted for (external) drivers
	Sep/Oct 1995, various modifications for v1.10
	09.11.1996 hidden parts which are not for PROforma external modules
*/

#include <sms.h>
#include <win.h>

#ifndef _PROforma_H
#include "PROforma.h"
#endif _PROforma_H

#ifndef catch
#define catch(x) do { if (err=(x)) return err; } while (0)
#endif

typedef struct {
		pt x,y; 				/* x and y coordinates */
} coor;

typedef struct _Bitmap *Bitmap;

typedef struct {
		short xsiz, ysiz;		/* size of mask in pixels */
		short linc; 			/* line increment */
		unsigned char base[2];	/* start of actual data */
} Mask;

typedef struct {
		pt xs, yr,				/* tranformation matrix */
		   xr, ys,				/*	 /	xs	yr	0 \  */
		   xd, yd;				/*	 |	xr	ys	0 |  */
} CTM;							/*	 \	xd	yd	1 /  */
								
#include "driver.h"

typedef struct _Bitmap {
		unsigned char *base;	/* base of memory with bitmap */
		short linc; 			/* line increment */
		int pinc;				/* plane increment */
		PBbox all;				/* bbox of max area */
		PBbox clip; 			/* bbox of area to draw in */

		PBbox patternbox;		/* size and offset (org) of current pattern */
		short pattlinc; 		/* line increment for pattern */
		int pattpinc;			/* plane increment for pattern */
		unsigned char *pattern; /* current pattern */

		short xcursor, ycursor; /* current cursor position */
		unsigned char *cursorpos;	/* cursor position in bitmap */
		short cursorbit;			/* offset in cursorpos where cursor is */
		unsigned int cursormask;	/* mask to set bit where cursor is */

		void *extra;			/* extra data for Bitmap driver */
		BitDrawRouts *bitdraw;	/* current drawing routs */
};

struct _Gstate {
	/* public part of the Gstate */

		char flag[15];			/* should be 'PROforma Gstate' */

		BITMdriver *bitmap; 	/* bitmap driver for this Gstate */
		DRIVdriver *printer;	/* printer driver for this Gstate */

		struct _DriverInfo *PrinterExtra;	/* extra data for Printer driver */
		Bitmap raster;			/* all information of the area to draw in */

		void *reserved; 		/* DO NOT USE, internal use of PROforma !! */

		coor ppp;				/* points per pixel (for conversion) */
		coor todev; 			/* pixels per point in default user space */
		
		PPageBbox pagebbox; 	/* device coordinates, max size of area in
								   raster which can be used - for this pass */
	/* added 04.11.2000, fontsize multiplier, needed for anti-aliased fonts */
		int fontsizemultiplier; /* multiplier for fontsize, "set" by driver */
};
